; Sibelius Access version 1.0 beta 2
;Contstants for Sibelius 5

CONST

;--- The mouse pointer always clicks one pixil to the left of the one passed
;This causes a misalignment between GetColorAtPoint() and MoveTo()
cMouseCorrection = 1,

;--- useful characters
bell = "\a",
comma=",",
delimiter="|",
newline = "\n",
space=" ",
colon = ":",
dash = "-",
period = "."

;--- Quotation marks need to be in message format
Messages
@MsgQuote
"
@@
EndMessages

Const

;For MSAA functions
MSAAClient = 0xFFFFFFFC,
MSAA_Checked = 0x100010,
MSAA_Unchecked = 0x100000,


csExitMidiTestHook = "ExitMidiTestHook",

;--- Input devices page of preferences
; pixil columns for the columns in the InputDevices list
pxDiactivateDevice = 14,
pxDeviceType = 216,
pxDeviceMap = 306,
; relyable pixil for the MIDI recieved indicator
pxTestMidiPrefX = 8,
pxTestMidiPrefY = 16,

;--- Playback (transport) window
; play button
pxPlayX = 11,
pxPlayY = 11,
;Timecode window
ciTimeCode6Chars = 6,
ciTimeCode7Chars = 7,
ciTimeCode8Chars = 8,
pxTimeCodeHorzOffset = 0,
pxTimeCodeVertOffset = 0,
pxTimeCodeColonX = 67,
pxTimeCodeColonY = 8,
pxTimeCodePeriodY = 14,
pxSMPTECols = "3|11|26|34|49|57|72|80",
pxTimeCodeRow1 = 6,
pxTimeCodeRow2 = 12,
pxTimeCodeRowLength = 6,
;pixil maps
pmtc0 = 1934,
pmtc1 = 3834,
pmtc2 = 4015,
pmtc3 =3055,
pmtc4 =3571,
pmtc5 =3070,
pmtc6 =1982,
pmtc7 =3935,
pmtc8 =1932,
pmtc9 =3054,

pxBarsBeatsCols = "6|13|20|27|39|46|53",
pxBarsBeatsRow1 = 10,
pxBarsBeatsRow2 = 13,
pxBarsBeatsRowLength = 6,
;Pixil maps
pmbb1 = 3575,
pmbb2 = 3807,
pmbb3 = 2031,
pmbb4 = 2851,
pmbb5 = 2045,
pmbb6 = 1917,
pmbb7 = 3295,
pmbb8 = 861,
pmbb9 = 2014,
pmbb0 = 1821,

;Metronome
pxMetronomeCol = 15,
pxMetronomeRow = 12,

;Tempo readout (BPM)
pxTempo_HorzOffset = 0,
pxTempo_VertOffset = 0,
pxTempoColumn = 17,
pxTempoRow1 = 6,
pxTempoRow2 = 12,
pxTempoCharSeparation = 8,
pxTempoRowLength = 6,

;Tempo slider
pxTempoSliderWidth = 56,
i_TempoSliderRow = 8,
s_TempoPercentages = "10|13|17|20|24|27|31|35|38|42|45|49|53|56|60|63|67|70|74|78|81|85|88|100|110|114|117|121|124|128|131|135|139|142|146|149|153|157|160|164|167|171|175",
Tempo_First = 0,
Tempo_Left = 1,
Tempo_Center = 2,
Tempo_Right = 3,
Tempo_Last = 4,

; for positioning the tool windows
;The coordinates are calculated from screen width and window width
ciPropertiesWidth = 170,
ciPlaybackWidth = 276,
ciKeypadWidth = 118,
ciToolWindowSep = 20,

;Post send values for windows
WM_SYSCOMMAND = 0x0112,
SC_SIZE = 0xF000,
SC_MINIMIZE = 0xF020,
SC_MAXIMIZE = 0xF030,
SC_MOVE = 0xF010,
SC_CLOSE = 0xF060,
SC_RESTORE = 0xF120,


;Commands passed to Access.plg through the ini file
;These are used by the plug-in method "DoExternalCommand"
Plg_SayInputtedPitch = "InputtedNote",
Plg_DescribePosition = "DescribePosition",
Plg_DescribeAll = "DescribeAll",
Plg_DescribeSelected = "DescribeSelected",
Plg_DescribePitchChange = "PitchChange",
Plg_Reselect = "ReselectLastItem",
Plg_MoveStart = "MoveToStart",
Plg_MoveEnd = "MoveToEnd",
Plg_MoveTop = "MoveToTop",
Plg_MoveBottom = "MoveToBottom",
Plg_FilteredTextDialog = "FilteredDlg",
Plg_Filtered = "Filtered",
Plg_ScoreInfo = "ScoreInfo",
Plg_ScoreLayout = "ScoreLayout",
Plg_StaffSummary = "StaffSummary",
Plg_InstrumentSummary = "InstrumentSummary",
Plg_SystemItems = "SystemItems",
Plg_cChangeVelocity = "0",
Plg_cChangePosition = "1",
Plg_cChangeDuration = "2",
Plg_cChangeSmall = "0",
Plg_cChangeMedium = "1",
Plg_cChangeLarge = "2",
Plg_cChangeDecrease = "0",
Plg_cChangeIncrease = "1",
Plg_SetSelectionMarker = "SetSelectionMarker",
Plg_SelectToMarker = "SelectToMarker",
Plg_SelectToStart = "SelectToStart",
Plg_SelectToEnd = "SelectToEnd",
Plg_VoiceUp = "GoToVoice|up",
Plg_VoiceDown = "GoToVoice|down",
Plg_LivePlayback = "LivePlayback",

;for checking if the current item is a system item
csSystem = "System",



;constant returned by ini read string when no key is found
csNoIniKey = "no key in section",

;Plug-in returned ini file keys
IniSection = "Data",
IniKeyMessage = "Say",
IniKeyRhythm = "Rhythm",
IniKeyPitch = "Pitch",
IniKeyDescription1_L = "Des1L",
IniKeyDescription1_S = "Des1S",
IniKeyDescription2_L = "Des2L",
IniKeyDescription2_S = "Des2S",
IniKeyDescription3_L = "Des3L",
IniKeyDescription3_S = "Des3S",
IniKeyDescription4_L = "Des4L",
IniKeyDescription4_S = "Des4S",
IniKeyMove = "Move",
IniKeyLivePlaybackPosition = "PlayPos",
IniKeyLivePlaybackDuration = "PlayDur",
IniKeyLivePlaybackVelocity = "PlayVel",
IniKeyTransposingScore = "Trans",
IniKeyPositionInChord = "PositionInChord",
IniKeyNoteInChordWritten = "NoteDes2",
IniKeyNoteInChordSounding = "Des3",
IniKeyColor = "Color",
IniKeyFilteredBefore = "FilteredBefore",
IniKeyFilteredAfter = "FilteredAfter",
IniKeyFilteredText = "Filtered",
IniKeyFilteredSpelt = "TrueFiltered",
IniKeyStaff = "Staff",
IniKeySystem = "System",
IniKeyInstrument = "Instrument",
IniKeyStaffObjects = "NrbStaff",
IniKeySystemObjects = "NrbSystemObjects",


;Flags for color and page number
IniFlagColor = "**color**",
IniFlagPage = "**page**",


;description types
Describe_SelectionOnly = 0,
Describe_AllAtPosition = 1,

; for identifying the position of a note within a chord
; These match the constants with the same names in Access.plg
cNoteInChord_Top = 0,
cNoteInChord_Middle = 1,
cNoteInChord_Bottom = 2,
cNoteInChord_More = 3,

;for identifying the type of movement that the calling script would normally initiate
Movement_Tab = 0,
Movement_PriorStave = 5, ;alt+ctrl+up/down
Movement_NextStave = 6,;alt+ctrl
;Movement_Part = 7, ;alt+up/down
;Movement_LinePoint = 8, ;alt+right/left
;Movement_SelectionPoint = 9, ;ctrl+[/]
;Movement_Up = 10,
;Movement_Down = 11,
;Movement_Selection = 12,
;Movement_SayAll = 13,
;Movement_Next = 14,
;Movement_Prior = 15,
;Movement_First = 16,
Movement_Vertical = 17,

;score object types
Edit = "Edit",
SO_Selection = "Passage",
SO_Note = "Note",
SO_Chord = "Chord",
SO_Rest = "Rest",
SO_BarRest = "Bar Rest",
SO_Line = "Line",
SO_CreateNoteRest = "Create Note/Rest",
SO_Text = "Text",
SO_SystemText = "System Text",
SO_Lyric = "Lyric",

;Note types for note input mode
Note_Standard = 0,
Note_Appoggiatura = 1,
Note_Acciaccatura = 2,

;keyboard layouts
ciDesktopLayout = 1,
ciLaptopLayout = 2,
csDesktopLayout = "Desktop",
csLaptopLayout = "Laptop",

;--- file and folder names
csPersonalizedSettings = "SibAccess",
csFreedomScientific = "Freedom Scientific",
csHelpContents = "Sibelius Access Guide\\Contents.html",
csJawsToSibelius = "Sibelius Software\\Sibelius 5\\Plugins\\Access\\JawsToSibelius.ini",
csPlugin = "Sibelius Software\\Sibelius 5\\Plugins\\Access\\Access.plg",
csResources = "Sibelius Access Resources",
csSibeliusToJaws = "Sibelius Software\\Sibelius 5\\Plugins\\Access\\SibeliusToJaws.ini",
csScoreInfoDoc = "Sibelius Software\\Sibelius 5\\Plugins\\Access\\ScoreSummary.html",
csScoreLayoutDoc = "Sibelius Software\\Sibelius 5\\Plugins\\Access\\ScoreLayout.html",


; key names for the JSI file
csJSI_Colors = "Colors",
csJSI_TemplateButton = "TBC",
csJSI_Options = "Options",
csJSI_TypingEcho = "TypingEcho",

;Values to write to JSI if it cannot be found
csJSI_TBCToWrite = "royalblue1",

;for line points
I_LineStart = 0,
I_LineBoth = 1,
I_LineMiddle = 2,
I_LineEnd = 3,


;Pixel coordinates for the grid grid in the symbols Dialog
PX_SymbolsGridLeftEdge = 102,
PX_SymbolsColumnWidth = 36,
I_NumSymbolRows = 38,
I_NumSymbolColumns = 16,

;Names of scripts
ScriptName_PlugInMode = "PlugInMode",

;WindowClasses
cWcMixer = "WindowsForms10.Window.20008.app.0",
cWcInputKeystroke = "msctls_hotkey32",
cWcSibSeparator = "SibSeparator",
cWcToolWindow = "GuiPopUpWindow",
cwcDialog = "#32770",
cWcPropertiesPain = "#32770",
cWcPropertiesPainButton = "OwnerDrawControl ",
cWcMDIFrame = "MDIFrameWindow",
cWcMDIClient="MDIClient",
cWcMDIChild="MDIChildWindow",
cWcComboBox = "ComboBox",
cWcEditTextItem = "GUIRICHEDIT",
cWcDLGEdit = "DLGEDIT_W",
cWcPlgDLGPallett = "DLGPAL_W",
cWcTabControl = "SysTabControl32",
cWcButton = "Button",

;names of the properties window
EditNote="Edit Note",
EditLine="Edit Line",
EditText="Edit Text",
EditChord="Edit Chord",
EditRest="Edit Rest",
EditBarRest="Edit Bar Rest",
NoSelection="No Selection",

gsPropertiesPains="General|Text|Playback|Lines|Bars|Notes",
ID_PropertiesPainsButtons = "7930|7944|104|7943|7945|7941",
ID_PropertiesPlaybackButton = 104,

;Text strings for identifying windows by name.
Name_FlexiTime = "Flexi-time Options",
Name_OKButton = "OK",
Name_CancelButton = "Cancel",
Name_NewScore = "New Score",
Name_InstrumentsAndStaves = "Instruments",
Name_Open = "Open",
Name_QuickStart = "Quick Start",
Name_StopPlugIn = "Stop Plug-in",
Name_PlaybackDevices = "Playback Devices",
Name_Navigator = "Navigator",
Name_Keypad = "Keypad",
Name_Playback = "Playback",
Name_Mixer = "Mixer",
Name_Kontakt = "Kontakt Player",
Name_Parts = "Parts",
Name_Video = "Video",
Name_Properties = "Properties",
Name_Find = "Find",
Name_Filter = "Advanced Filter",
Name_Lines = "Lines",
Name_App = "Sibelius",
Name_ManuscriptPaper = "Manuscript Paper" ,
Name_Housestyle = "House Style",
Name_TimeSignatureAndTempo = "Time Signature and Tempo" ,
Name_KeySignature = "Key Signature" ,
Name_TimeSignature="Time Signature",
Name_Preferences = "Preferences",
Name_ScoreInfo = "Score Info" ,
Name_Symbols = "Symbols",
Name_UndoHistory="Undo History ",
Name_AddKeystroke="Add Keyboard Shortcut",
Name_PlgMethod = "ManuScript Method",
Name_PlgMethodEdit = "(e.g. x, y, z)",
Name_PlgData = "ManuScript Data",
Name_PlgTrace = "Plug-in Trace",
Name_Color = "Color",
Name_Clef = "Clef",
Name_SpecialFunctions="Special Functions",
Name_ChangeStaffName = "Change Staff Name",
Name_VerbosityDlg = "Configure Verbosity Preset",
Name_MessageDlg = "Message",
Name_ClickStrip = "Click",
Name_MasterVolume = "Master Volume",
Name_OpenMidiFile = "Open MIDI File",
Name_PlaybackDictionary = "Playback Dictionary",
Name_Transform = "Transform Live Playback",

; Mixer controls
cTolleratedBottomOfMixer = 700,
cDesiredBottomOfMixer = 740,
cStaffStrip = 1,
cGroupStrip = 2,
cVIStrip = 3,
cBusStrip = 4,
cMasterStrip = 5,
cNumCtrlsInStaffStrip = 5,
cNumCtrlsInGroupStrip = 4,
cVolumeSliderStart = 8,
cVolumeSliderEnd = 140,
cVolumeStickyLeft = 103,
cVolumeStickyRight = 110,
cVolumeStickyMid = 107,
cVolumeSliderPixilsToCenter = 3,
cMixerScrollTopEdge = 16,
cMixerScrollTopPos = 156,
cMixerScrollMidPos = 296,
cMixerScrollBottomPos = 436,
cMixerScrollBottomEdge = 576,
cStripButtonPixelX = 0,
cStripButtonPixelY = 16,
ciMasterVolumeRedLimit = 192,
ciStripRBDiffLimit = 4,

;--- Dialog Editor
ciDLGEditorScaleX = 150,
ciDLGEditorScaleY = 163,
ciPallettSpacing = 32,
ciPallettVertOffSet = 6,
ciPallettHorzOffSet = 15,
ciDLGEditorOffSet = 16,

;f keys for keypad templates
cksFKeys = "f8|f9|f10|f11|f12",

;playback coordinates
Px_MIDIX = 7,
Px_MIDIY = 5,

;Binary integers for keypad graphics
B_KeypadTemplates="1|2|4|8|16",
B_NumPadSlash=32,
B_NumPadStar=64,
B_NumPadMinus=128,
B_NumPad7=256,
B_NumPad8=512,
B_NumPad9=1024,
B_NumPad4=2048,
B_NumPad5=4096,
B_NumPad6=8192,
B_NumPad1=16384,
B_NumPad2=32768,
B_NumPad3=65536,
B_NumPad0=131072,
B_NumPadDelete=262144,
B_NumPadEnter=524288,
b_Voices="1048576|2097152|4194304|8388608|16777216",

 ;Pixil coordinates for keypad graphics.
I_TemplateButtonPixilRow = 13,
S_TemplateButtonPixilColumns = "7|27|47|67|87",
S_KeypadPixilRows ="13|13|13|13|13|29|29|29|57|57|57|85|85|85|113|113|113|141|141|141|181|181|181|181|181",
S_KeypadPixilColumns ="7|27|47|67|87|29|57|85|1|29|57|1|29|57|1|29|57|29|57|85|7|27|47|67|87",

;Colors for Keypad graphics
S_CurrentTemplateColor ="royal",
S_Gray="gray",
S_Gainsboro="gainsboro",

;keypad graphics

;names of the number pad keys in the order that they will be scanned by get keypad graphics
NumPadKeys = "numpadslash|numpadstar|numpadminus|home|uparrow|pageup|leftarrow|numpad5|rightarrow|end|downarrow|pagedown|numpadinsert|delete|numpadenter",

;maps the key code from the number row to the equivalent number pad name
csKeypadToRow = "end|downarrow|pagedown|leftarrow|numpad5|rightarrow|home|uparrow|pageup|numpadinsert",

;names not included in common jsm
cksNumPadSlash = "numpadslash",
cksNumPadStar = "numpadstar",
cksNumPadMinus = "numpadminus",

;--- Find DLG
csFindDLGViewNotes = "Notes and Chords",
csFindDLGViewRests = "Rests and Bar Rests",
csFindDLGViewText = "Text",
csFindDLGViewLines = "Lines"

