;Sibelius Access version 1.0 beta 2
;Control IDs for Sibelius 5

Const

ID_EditTextItem = 100,
ID_ZoomLevel = 1001,

;Properties Window
ID_PropertiesGeneralPainButton = 7930,
ID_PropertiesEdit = 1000,
;General pain
ID_Stave = 411,
ID_Bar = 412,
ID_X=414,
ID_Y=415,
ID_Position = 445,
ID_PageNumber = 7432,
;Text pain
ID_TextType = 455,
ID_TextSize=462,
ID_TextSizeSpinControl = 464,
ID_TextFont=466,
ID_TextBold=468,
ID_TextItalic=471,
ID_TextUnderline=474,
;lines pain
ID_rhX = 454,
ID_rhY = 470,
ID_MidX = 478,
ID_MidY = 481,
;Notes pain
ID_Pitch = 11095,
ID_NoteHead=432,

;Lists of control IDs in properties window
ID_PropertiesGeneralControls = "414|415|434",
ID_PropertiesTextControls = "455|462|466|468|471|474",
ID_PropertiesLinesControls = "478|481|454|470|510|512|514|516",
ID_PropertiesNotesControls = "444|417|419|421|423|4425|1131",
ID_PropertiesPlaybackControls = "1099|1100|1101|1102|1103|1104|1105|1107|1093|1096|1094|1097|1095|1098|4469|4472|4456|4477|4461|3484|4465|475|4486|4488|1112|1122|1134|4487",


;Playback
ID_PlaybackClick = 136,
ID_PlaybackTempoSlider = 137,
ID_PlaybackTimeLine = 138,

;Playback devices
ID_PlaybackActiveDevices = 1013,
ID_PlaybackSave = 1003,

;Parts window
ID_PartsList = 100,

;New Score Controls
ID_NewScorePageName = 1005,
ID_NewScoreNext=1001,
ID_ManuscriptPaper = 100,
ID_HouseStyle = 1011,
ID_NewScoreMajorKeys = 1002,
ID_NewScoreMinorKeys = 1004,
ID_NewScoreSharps = 102,
ID_NewScoreFlats = 105,
ID_NewScoreTwoTwo = 2221,
ID_NewScoreOther = 122,
ID_NewScoreDenominator = 130,
ID_NewScoreNumerator = 131,
ID_NewScoreBeamAndRest = 2228,
ID_NewScorePickUpCheckBox = 133,
ID_NewScorePickUpEdit = 132,
ID_NewScoreTempoText = 1017,
ID_NewScoreBeatLength = 134,
ID_NewScoreMetronome = 135,
ID_NewScoreBeatsPerMinute = 1015,
ID_NewScoreTitle = 104,
ID_NewScoreTimeSignatureControls= "2221|2222|2223|2224|2225|2226|2227|122|131|130|2228|133|132|1017|135|134|1015",

;Time Signature Dialog
ID_TimeSigEditCombo = 1001,
ID_TimeSigOK = 1,
ID_TimeSigCancel = 2,
ID_TimeSigGroups = 3,
ID_TimeSigRewrite = 121,
ID_TimeSigOther = 0,
ID_TimeSigTwoTwo = 0,
ID_TimeSigCautionary = 115,
ID_PickUpCheckBox = 120,
ID_TimeSigNumerator = 118,
ID_TimeSigPickUpEdit = 119,
ID_TimeSignatureControls= "100|101|102|103|104|105|106|118|117|120|119",

;KeySignature Dialog
ID_KeySignatureSharps = 15402,
ID_KeySignatureFlats = 15404,
ID_KeySigMajor = 1000,
ID_NewScoreKeySigMajor = 1002,
;Instruments And Staves
ID_StavesInScore = 103,
;Preferences
ID_PrefMainList = 10000,
ID_MenuCategory = 2004,
ID_PrefFeature = 2006,
ID_AddKeystroke = 2021,
ID_PrefText = 5113,
ID_PrefShortcut = 5116,
ID_InputDevices = 1089,
;Add keystroke
ID_AddKeyStrokeOK = 1,
ID_AddKeystrokeCancel = 2,
ID_AddKeystrokeEdit = 103,

;Lines dialogue
ID_StaffLines = 113,
ID_SystemLines = 111,

;Symbols Dialog
ID_SymbolsList = 100,

; Find dialog controls
ID_FindDLGAllLines = 1114,
ID_FindDLGTextContaining = 1014,
ID_FindDLGRestsButton = 1044,
ID_FindDLGNoteHeads = 1025,
ID_FindDLGFindButton = 1,
ID_FindDLGFirstArticulation = 1092,
ID_FindDLGLastArticulation = 1111,
ID_FindDLG_StaticArticulations = 1037,
ID_FindDLGEditCombo = 1001,
ID_FindDLGTuplets = 1113,
ID_FindDLGBarRestsButton = 1046,
ID_FindDLGNoneButton = 3340,
ID_FindDLGStaffLines = 1082,
ID_FindDLGSystemLines 1083,
ID_FindDLGScore = 1117,
ID_FindDLGSelection = 1119,
ID_FindDLGAnyArticulation = 1048,
ID_FindDLGAllArticulations = 1049,
ID_FindDLGViewList = 1038,
ID_FindDLGNoteControls = "1025|1033|1022|1028|1041|1112|1042|1043|1092|1094|1095|1097|1099|1101|1102|1103|1104|1105|1106|1107|1108|1109|1110|1111|1048|1049|1113",
ID_FindDLGRestControls = "1044|1024|1031|1027|1030|1046",
ID_FindDLGTextControls = "1014|1120|3339|3340",
ID_FindDLGLineControls = "1114|1082|1083",
ID_FindDLGFixedControls = "1117|1119|1038|1016|1017|1019|1018|1008|1010|1005|1012",

;Undo History
ID_UndoHistoryList=100,

;Color DLG
ID_ColorRed=706,
ID_ColorGreen=707,
ID_ColorBlue=708,
ID_StandardColors=720,

;Score info dialog
ID_ScoreInfoOK = 1,
ID_ScoreInfoTitle = 100,
ID_ScoreInfoIdeas = 1001,

;Open MIDI file dialog
ID_OpenMidiOK = 1,
ID_OpenMidiAdjustRhythms = 1101,
ID_OpenMidiSoundSetCheckBox = 115,

;Transform live playback dialog
ID_TransformVelocityRadioStart = 1015,
ID_TransformVelocityRadioEnd = 1028,
ID_TransformTimingsRadioStart = 1001,
ID_TransformTimingsRadioEnd = 1009,
ID_TransformOK = 1,

;Plugin Editer and related DLGs
ID_PlgEditorCancel = 2,
ID_PlgMethodOK =1,
ID_PlgMethodCancel =2,
ID_PlgMethodParam = 101,
ID_PlgMethodEdit =102,
ID_PlgMethodSyntax =103,
ID_PlgMethodName = 100,
;Plug-in Trace
ID_PlgTraceClose = 103,
;data editer
ID_PlgDataOK = 1,
ID_PlgDataCancel = 2,
ID_PlgDataEdit = 100,

;Change staff name
ID_OKChangeStaffName = 0,
ID_CancelChangeStaffName = 5,

;Playback dictionary dialog
ID_PlayDictCancel = 2