;Sibelius Access version 1 beta 2
;Messages for assessing and fixing windows

Messages

@MsgNoFrameWindow
The main Sibelius window could not be found.
This is a serious bug and must be reported to the developers.
@@

@MsgWindowCoordinates
%1x%2 - %3x%4
@@

@MsgWindowDataForDebug
%1: %2
@@

@MsgMainWindowMaximizeAlert
The main Sibelius window can not be maximized.
Press Control+Windows+Tab until you are in the score window.
Press Alt+Space to open the system menu and choose maximize.
Now try fixing the tool windows again.

Press Escape to close this message.
@@

@MsgGiveToolWindowFocusNoScore
You cannot move to a tool window when no score is open.
@@

@MsgGiveToolWindowFocusWrongFocus
You cannot move to a tool window from here.
Return to the score and try again.
@@

@MsgScoreFocusAbort
You cannot go to the score from here.
@@

@MsgToolWindowName
%1 window
@@

@MsgOpenPropertiesPainsSingle
The %1 pain is open.
@@
@MsgOpenPropertiesPainsPlural
The %1 and %2 pains are open.
@@

@MsgTaskBarCollision
The %1 window is colliding with the task bar. Press Ctrl+Shift+F1 to optimize the tool windows.
@@
@MsgToolWindowCollision
The %1 and %2 windows are overlapping. Press Ctrl+Shift+F1 to optimize the tool windows.
@@

@MsgToolWindowCorrectPosition
This window is correctly positioned and does not need to be moved.
@@

@MsgToolWindowMoveAlert1
This window needs to be moved.
Press Alt+Space to open the system menu and choose move.
@@
@MsgToolWindowMoveAlert2
Press %1 %2 times.
@@
@MsgToolWindowMoveAlert3
Then press enter.
You may have to choose the fix tool windows option once more after moving the window.

Press Escape to close this message.
@@

@MsgOpened
opened
@@

@MsgClosed
closed
@@

@MsgToolWindowOpen
%1 window open
@@

@MsgToolWindowClosed
%1 window closed
@@

@MsgToolWndOpenAlert
The %1 window is open and needs to be closed. Go to the window menu and make sure that %1 is not checked.
@@
@MsgToolWndClosedAlert
The %1 window is closed and needs to be opened. Go to the window menu and make sure that %1 is checked.
@@

@MsgToolWndNotFound
The %1 window cannot be found. This is a serious problem. Pleas contact the developers.
@@

@MsgToolWndMoveAlert
The %1 window needs to be moved. Press %KeyFor(FixToolWindows)
@@

@MsgFixToolWindowsNoScore
You cannot fix the tool windows when no score is open.
@@
@MsgFixToolWindowsWrongFocus
You cannot fix the tool windows from here.  Please return to the score and try again.
@@

@MsgToolWindowsFound
All tool windows have been found.
@@

@MsgToolWindowFailHandle
The following tool windows could not be found:%1

Try restarting JAWS.
If this does not fix the problem then try restarting Sibelius.
If this does not fix the problem the try restarting Windows.
If the problem still occurs then please contact the developers.
@@

@MsgToolWindowOpenFailed
The %1 window could not be opened.
@@
@MsgToolWindowCloseFailed
The %1 window could not be closed.
@@

@MsgToolWindowKeystrokeAlert
Try pressing the keystroke %1 several times.
This keystroke should alternately open and close the %2 window.
If this does not happen then make sure that the keystroke you are using is the same as the one shown in Sibelius' window menu.
Press Alt+W and DownArrow to %2.
The keystroke spoken after %2 should be %1.
If this is not the case then you must change either the keystroke in the Sibelius preferences dialog or the keystroke in the JAWS keyboard manager.
Consult the guide for further details.

Press Escape to close this message.
@@

@MsgToolWndUserMustToggle
The user must open and close the tool windows manually
@@

@MsgToolWndNoToggleNeeded
The correct tool windows are open or closed.
@@

@MsgToolWindowFocusFailed
The %1 window did not get focus.
Try running this feature again.
@@

@MsgToolWindowFocusSuccess
The %1 window gained focus.
@@

@MsgToolWindowNoMoveRequired
The %1 window is correctly positioned.
@@

@MsgToolWindowMoveRequired
The %1 window needs to be moved from %2x%3 to %4x%5.
@@

@MsgToolWindowMoveWithKeystrokesSuccess
Keystrokes had to be used to move the %1 window to  %2x%3.
@@

@MsgToolWindowMoveWithKeystrokesFailed
The %1 window was partially off the screen and needed to be moved by using keystrokes.
Unfortunately this could not be done automatically.
Press Control+Windows+Tab until the %1 window has focus.
Then press Shift+Windows+Tab for further instructions.

Press Escape to close this message.
@@

@MsgToolWindowMoveSuccess
The %1 window was successfully moved.
@@

@MsgToolWindowMoveFailed
The %1 window could not be dragged with the mouse.
Press Control+Windows+Tab until the %1 window has focus.
Then press Shift+Windows+Tab for further instructions.

Press Escape to close this message.
@@

@MsgPropertiesPainFail
The properties pains cannot be configured.  Do the following:

1. Press f2 and choose configure properties pains.
2. Use the arrow keys to move between each pain.
3. If the pain is wrongly configured, JAWS will tell you to open or close it.
4. Press Space to open or close the pain.
5. Press Enter when you've finished.
@@

@MsgFixToolWindows_S
Fix tool windows
@@
@MsgFixToolWindows_L
The tool windows need fixing. Press Control+Shift+F1
@@

@MsgToolWindowsFixed_S
Tool windows fixed.
@@
@MsgToolWindowsFixed_L
The tool windows have been fixed.
@@

@MsgToolWindowFixFailure
The tool windows could not be fixed.
Try running this function again.
If the problem persists then press Control+F1 to open the Access menu and choose Trace Tool Windows.
This will open a text document which shows you exactly what JAWS tried to do and where the fix tool window function failed.

Press Escape to close this message.
@@

@MsgTraceErrorNotice
*ERROR*
@@

@MsgOpenPropertiesPainFailed
The %1 pain of the properties widnow could not be opened.
@@
@MsgClosePropertiesPainFailed
The %1 pain of the properties window could not be closed.
@@

EndMessages