;Sibelius Access version 1 beta 2
;Messages and language specific constants for Sibelius 5

Messages

@MsgSibAccessVersion
Sibelius Access version 1 Release candidate 1
@@

@MsgSibAccessLoaded
Sibelius Access settings are loaded
Press Control + F1 to open the Sibelius Access Options menu
@@


;error messages
@MsgAccessError
Sibelius Access Error
@@

;no keyboard layout could be detected
@MsgNoKeyboardLayout
The keyboard layout could not be detected. Press Ctrl+F1 and choose Laptop layout or Desktop layout.
@@

; the color or typing echo could not be retrieved from the JSI file
@MsgNoColorFromJSI
An error occured whilst trying to read the JAWS personalized settings file. Please contact the developers.
@@

;for testing the plugin

@MsgNoPlugin
The ACCESS plug in has not been installed.
It is vital that you do this before proceeding.
Shut down Sibelius and read the plug ins section of the installation instructions.
Press Escape to close this message.
@@
@MsgPlugInRunFalse
The plug in is not running correctly.
Press Control + F1 to open the Sibelius Access menu and choose Test Plug-in.
Press Escape to close this message.
@@
@MsgPlugInRunTrue
The plug in is running normally
@@

@MsgPlugInIniKeyFail
The information you requested could not be found in the plug in file. Press F5 to refresh the plug in and try again.
@@

;for typing echo changes
@MsgTypingEchoInScore
%1
Remember that the typing echo is always set to none in the score window.
@@

@MsgWinTypeDLG
Dialog
@@

@MsgSibelius
Sibelius
@@
@MsgScoreWindow
score window
@@

;for dialog page change
@MsgDialogPageChange
%1 page
@@

;For focusing in the text item edit box.
@MsgEditTextItem
Edit %1 text
@@

;zooming

@MsgZoomLevel
Zoomed to %1
@@

@MsgTextZoomAlert
Warning! The zoom level is not right for text editing.
@@

;--- words for concatonated strings
@MsgWordAt
at
@@

;--- quick navigation
@MsgQuickNavNoMove_S
Cannot move %1 in quick navigation mode
@@
@MsgQuickNavNoMove_L
Cannot move this %1 in quick navigation mode.  Switch to detailed mode and try again.
@@

;--- status announcements
@MsgPleaseWaite
Please waite
@@
@MsgAnnouncementOff
off
@@
@MsgAnnouncementOn
on
@@
@MsgOpen
Open
@@
@MsgClose
Closed
@@

;--- Access options menu
@MsgSpecialFunctions
Sibelius Access Options
@@
@MsgAccOptScoreSummary
Score summary
@@
@MsgAccOptScoreLayout
Pages, systems and bars
@@
@MsgAccOptDesktop
Keyboard layout is desktop
@@
@MsgAccOptLaptop
Keyboard layout is laptop
@@
@MsgAccOptGuide
Sibelius Access Guide
@@
@MsgAccOptSystemObjects
System Items
@@
@MsgAccOptInstrumentNames
Staff Names
@@
@MsgAccOptVerbosity
Verbosity Options
@@
@MsgAccOptRegistration
Registration Info
@@
@MsgAccOptFixWindows
Optimise Tool Windows
@@
@MsgAccOptAutoToggle
Open and close tool windows automatically
@@
@MsgAccOptManualToggle
Open and close tool windows manually
@@
@MsgAccOptPlugInOff
Plug-in not in use
@@
@MsgAccOptPlugInOn
Plug-in in use
@@
@MsgAccOptMIDI
Test MIDI I/O
@@
@MsgAccOptResources
Open Sibelius Access Resources Folder
@@
@MsgAccOptBugReport
Bug report
@@
@MsgAccOptTraceToolWindows
Optimize tool windows log
@@
@MsgAccOptTestPlug
Test Plug-in
@@
@MsgAccOptIni
Open ini file from plug-in
@@
@MsgAccOptKPColors
Get keypad colors
@@


; toggling the plug-in 
@MsgPlugInTrue_L
The plug in has been enabled
@@
@MsgPlugInTrue_S
Plug in enabled
@@
@MsgPlugInFalse_L
The plug in has be disabled
@@
@MsgPlugInFalse_S
Plug in disabled
@@

; for the input devices page of preferences
@MsgInputDevicesOptions
Activate or diactivate Device
|Change type
|Change Input Map
|Test MIDI
@@
@MsgMidiReceived
Receiving
@@

; for inputting in tab staves
@MsgChooseString_S
Choose a string
@@
@MsgChooseString_L
Choose a string to add a 0 to.
@@

;--- Playback
@MsgMIDIIn
in
@@
@MsgMIDIOut
out
@@
@MsgHourSingle
hour
@@
@MsgHourPlural
hours
@@
@MsgMinuteSingle
minute
@@
@MsgMinutePlural
minutes
@@
@MsgSecondSingle
second
@@
@MsgSecondPlural
seconds
@@
@MsgFrameSingle
frame
@@
@MsgFramePlural
frames
@@
@MsgStartOfScore
Start of score
@@
@MsgNoTime
Cannot get time
@@
@MsgMetronome
Metronome %1
@@
@MsgBPM
%1 beats per minute
@@
@MsgTempoFail
cannot get tempo
@@

;for properties navigation
@MsgPropertiesNavigationOn
Properties window navigation is on.
Press JAWSKey+F1 for help.
Press Escape to exit properties navigation mode.
@@
@MsgPropertiesNavigationOff
Exiting properties navigation and returning to score.
@@
@MsgPropertiesNavigationHelp
This message is not shown in the virtual viewer.
The properties navigation mode is on.
Use left and right arrows to move between the pains of the properties window.
Press space to open or close the pain.
Press any other key to exit properties navigation mode.
@@

@MsgPropertiesPainButtonPressed
%1 pain button pressed
@@
@MsgPropertiesPainButtonNotPressed
%1 pain button not pressed
@@

@MsgPropertiesGeneralControls
X coordinate|Y coordinate|Hide or show
@@

@MsgPropertiesTextControls
Text style|Size|Font|Bold|Italic|Underline
@@

@MsgPropertiesLinesControls
Curvature X|Curvature Y|Right end X|Right end Y|Closed end of hairpin|Open end of hairpin|Small end of hairpin|Large end of hairpin
@@

@MsgPropertiesNotesControls
X for accidental|Left end of tie|Right end of tie|Height of right end of tie|Height of middle of tie|Percentage of shoulder of Tie|Default shoulder of tie
@@

;--- controls in the playback pain of the properties window

@MsgPropertiesPlaybackFailure
The properties pains could not be configured.
Please try again.
@@
@MsgPropertiesPlaybackControls
Pass 1|Pass 2|Pass 3|Pass 4|Pass 5|Pass 6|Pass 7|Pass 8
|Velocity |Velocity|Start position|Start position|duration|Duration
|Glissando type
|Shape of curve
|end value of curve
|BPM or percentage of starting BPM
|End percentage
|Percentage of maximum or starting velocity
|Half steps between notes
|Notes per second
|Play straight
|Start on upper note
|Last ending
|Jump at bar end
|Play tremolo
|Diatonic trill
@@



;for announcements of score items within the stave
@MsgNoScoresOpen
no scores are open
@@
@MsgNoSelection_L
There is no selection, press Ctrl+Home to select the first note or rest in the score.
@@
@MsgNoSelection_S
no selection
@@
@MsgNoColor
cannot get color
@@

@MsgNotALine
this is not a line
@@

@MsgBar
Bar
@@
@MsgBeat
beat
@@
@MsgRest
Rest
@@
@MsgBarRest
Bar Rest
@@
@MsgChord
Chord
@@

;Input mode

@MsgInputNotesReject
You cannot begin note input unless a rest, note or chord is selected.
@@
@MsgInputNotesOff
exiting input mode
@@
@MsgInputNotes
Starting note input at quarter %1
@@
@MsgInputNotesApp
Starting appoggiatura note input at quarter %1
@@
@MsgInputNotesAcc
Starting acciaccatura note input at quarter %1
@@
@MsgInputNotesLayout
Showing %1 layout
@@
@MsgInputNotesHighlightedSingle
%1 is highlighted
@@
@MsgInputNotesHighlightedMultiple
%1 and %2 are highlighted
@@

@MsgChangeVoice
changing to %1
@@

;For pitch announcements
@MsgPitchesLetters
Ay|Be|C|D|E|F|G
@@
@MsgPitchesPhonetic
alpha|bravo|charly|delta|echo|fox trot|golf
@@
@MsgAccidentals
Sharp|Flat|Double sharp|Double flat|Quarter sharp|Quarter flat|Three quarter sharp|Three quarter flat
@@
@MsgIntervals
Unison|Second|Third|Fourth|Fifth|Sixth|Seventh|Octave|Ninth
@@
@MsgBelow
Below
@@
@MsgAbove
Above
@@

;lyric position
@MsgNewLyricPosition
now at %1 quarter %2
@@

;For X and Y coordinates
@MsgItemCannotMove
You cannot move this item.
Press Alt+Control+Shift+F5 to remove this restriction.
@@
@MsgAllowItemToMove
You can now move this item.
@@
@MsgItemCoordinates
Coordinates are %1, %2
@@
@MsgLineCoordinates
Left end. %1, %2. Right end. %3, %4
@@
@MsgSlurCoordinates
Left end. %1, %2. Curvature. %3, %4. Right end. %5, %6.
@@
@MsgLeftEndOfLine
left end. %1, %2
@@
@MsgBothEndsOfLine
Both ends
@@
@MsgCurvatureOfLine
Curvature. %1, %2
@@
@MsgRightEndOfLine
right end. %1, %2
@@


@MsgAddBarEnd
Adding bar to end
@@

@MsgDurationsAmerican
Long
|DoubleWhole
|Whole
|Half
|Quarter
|Eighth
|Sixteenth
|ThirtySecond
|SixtyFourth
|OneHundredTwentyEighth
|TwoHundredFiftySixth
|FiveHundredTwelth
@@
@MsgDots
Dotted|Double Dotted|Tripple Dotted
@@
@MsgArticulations
Custom1 Articulation
|Staccato
|Staccatissimo
|Wedge
|Tenuto
|Accent
|Marcato
|Harmonic
|Plus
|Up Bow
|Down Bow
|Custom 2 Articulation
|Square Pause
|Pause
|Triangular Pause
|Custom3Articulation
@@

;for KeyPad templates

@MsgKeypadGraphicsError
The keypad graphics cannot be properly detected.
Open the preferences dialog and make sure that the tool windows are not translucent.
If this makes no difference, press Ctrl+F1 to open the Sibelius Access menu and choose get keypad colors.
@@

@MsgNoChangeKeypad_S
Not in score
@@
@MsgNoChangeKeypad_L
You can only change the keypad layout from the score and when the PC cursor is active.
@@
;If translating this message, vertical bars must remain
@MsgKeypadTemplates
Common notes|Small notes|Tremolos and beams|Articulations|Accidentals
@@
@MsgNoKeypadTemplate
No Keypad Template
@@
@MsgKeypadTemplateError
The keypad template did not change correctly, the current template is 
@@
;NumPad key aliuses
@Msg_NumPad0
rest|bar rest|remove all tremalos|remove all articulations|remove all accidentals
@@
@Msg_NumPadDelete
rhythm dot|slide|not assigned|open|not assigned
@@
@Msg_NumPadEnter
tied|cue size note|tremalo with next note|not assigned|bracket accidental
@@
@Msg_NumPad1
32nd note|brackets round note head|1 stroke|fermata|natural then flat
@@
@Msg_NumPad2
16th note|double rhythm dot|2 strokes|short fermata|three quarter sharp
@@
@Msg_NumPad3
8th note|tripple rhythm dot|3 strokes|long fermata|three quarter flat
@@

@Msg_NumPad4
quarter note|64th note|four strokes|closed|natural then sharp
@@
@Msg_NumPad5
half note|128th note|5 strokes|up bow|quarter sharp
@@
@Msg_NumPad6
whole note|256th note|buzz roll|down bow|quarter flat
@@

@Msg_NumPad7
natural|512th note|start beam|wedge|natural
@@
@Msg_NumPad8
sharp|double whole note|mid beam|marcato|sharp
@@
@Msg_NumPad9
flat|long note|end beam|staccatissimo|flat
@@
@Msg_NumPadSlash
accent|appogiatura|start secondary beam|custome articulation 1|double sharp
@@
@Msg_NumPadStar
staccato|acciacatura|no beam|custome articulation 2|double flat
@@
@Msg_NumPadMinus
tenuto|pre bend|not assigned|custome articulation 3|not assigned
@@

@MsgKeypad1
Accent
|Staccato
|Tenuto
|Natural
|Sharp
|Flat
|Quarter note
|Half note
|Whole note
|32nd note
|16th note
|8th note
|Rest
|rhythm Dot
|Tie
@@
@MsgKeyPad2
Appoggiatura
|Acciaccatura
|PreBend
|512th note
|DoubleWhole note
|LongNote note
|64th note
|128th note
|256th note
|Brackets
|DoubleDotted
|TrippleDotted
|BarRest
|Slide
|CueSize
@@
@MsgKeyPad3
SecondryBeam
|NoBeam
|Not assigned
|StartBeam
|MidBeam
|EndBeam
|4 strokes
|5 strokes
|buzz role
|1 stroke
|2 strokes
|3 strokes
|not assigned
|not assigned
|Tremolo with next note
@@
@MsgKeyPad4
Custome 1
|Custome 2
|Custome 3
|Wedge
|Marcato
|Staccatissimo
|Closed
|UpBow
|DownBow
|Fermata
|ShortFermata
|LongFermata
|RemoveAll
|Open
|not assigned
@@
@MsgKeyPad5
DoubleSharp
|DoubleFlat
|not assigned
|Natural
|Sharp
|Flat
|Natural then sharp
|quarter sharp
|quarter flat
|Natural then flat
|three Quarter Sharp
|three quarters flat
|RemoveAll
|not assigned
|BracketsRoundAccidental
@@
@MsgVoices
voice 1| voice 2| voice 3| voice 4|all voices
@@

;--- preferences dialog
@MsgPrefMainListName
Showing page
@@
@MsgNoKeyStroke
No Keystroke
@@

;--- find dialog
@MsgFindDLGFixedControls
find in whole score
|find in selection only
|view
|find notes and chords
|find rests and bar rest
|find text
|find lines
|voice 1
|voice 2
|voice 3
|voice 4
@@

@MsgFindDLGNoteControls
note head
|note in chord
|sounding pitch
|octave
|duration
|any position in bar
|position in bar
|multiples of this position
|custome  articulation 1
|staccato
|staccatissimo
|half staccato
|tenuto
|accent
|marcato
|open
|+
|up bow
|down bow
|custom articulation 1
|square pause
|fermata
|tri pause
|custom articulation 3
|any of these articulations
|all of these articulations
|tuplets
@@

@MsgFindDLGRestControls
find rests
|duration
|any position in bar
|position in bar
|multiples of this position
|find bar rests
@@

@MsgFindDLGTextControls
text containing
|text style
|select all styles
|deselect all styles
@@

@MsgFindDLGLineControls
select all lines
|staff lines
|system lines
@@




;Mixer
@MsgMixerResizeAlert
The mixer needs to be resized. Press %KeyFor(ResizeMixer).
@@
@MsgMixerTaskBarAlert
The bottom of the mixer is below the top of the task bar and needs to be resized. Press %KeyFor(ResizeMixer).
@@

@MsgMixerMaxed
The mixer is maximized.
@@
@MsgMixerModeOn
Entering Mixer mode.
@@
@MsgMixerModeOff
Leaving mixer mode
@@
@MsgShowingMxrStrip1
The %1 strip is showing
@@
@MsgShowingMxrStrip2
The %1 and %2 strips are showing
@@
@MsgStripButtonsFailure
There is more than one type of strip showing.
Try pressing control+tab.
@@
@MsgStripTypeChange
now showing %1 strips
@@
@MsgMixerStripTypes
Staff|Group|VST|Effect Bus|Master volume
@@
@MsgUnsupportedStrip
This type of strip is not supported.
@@
@MsgMuteOn
Muted
@@
@MsgHalfMuted
Half muted
@@
@MsgMuteOff
Not muted
@@
@MsgMuteUnavailable
Mute unavailable
@@
@MsgSoloOn
Soloed
@@
@MsgSoloOff
Not soloed
@@

; scrolling the mixer

@MsgMxrFirstStrip
First strip
@@
@MsgMxrLastStrip
Last strip
@@
@MsgMxrMustDown
The mixer must be scrolled down
@@
@MsgMxrMustScrollUp
The mixer must be scrolled up
@@
@MsgScrollingDown
Scrolling down
@@
@MsgScrollingUp
Scrolling up
@@
@MsgMxrScrollNone
The mixer does not need to be scrolled
@@
@MsgMxrScrollTop
Top of mixer
@@
@MsgMxrScrollBottom
Bottom of mixer
@@
@MsgMxrScrollMid
Middle of mixer
@@
@MsgMixerModeKeyReject
Not available in mixer mode
@@
@MsgVolumeMIDI
MIDI volume = %1
@@
@MsgVolumeDB_S
%1 dB
@@
@MsgVolumeDB_L
Volume = %1 dB
@@





;Key signature dialogs
@MsgSharpKeys
Sharp keys
@@
@MsgFlatKeys
Flat keys
@@


;Time Signature Dialog
@MsgTimeSignatureControls
two two
|two four
|three four
|four four
|six eight
|common time
|cut time
|numerator
|denominator
|pick up bar
|Length of Pick Up Bar
@@

;for new score dialog
;the time signature controls are slightly different so need listing again
@MsgNewScoreTimeSignatureControls
two two
|two four
|three four
|four four
|six eight
|common time
|cut time
|other
|numerator
|denominator
|Beam and rest groups
|pick up bar
|Length of Pick Up Bar
|Tempo text
|Metronome mark
|Note length
|Notes per minute
@@





; lines dialog
@MsgStaffLines
Staff Lines
@@
@MsgSystemLines
System lines
@@






; Symbols DLG

@MsgSymbolsTableName
Symbols
@@
@MsgSymbolsTableType
Table
@@
@MsgSymbolString
Symbol %1
@@
@MsgSelectedSymbol
Selected %1
@@
@MsgSymbolTablePosition
row %1 symbol %2 of 16
@@






;--- Plug-in editor

@MsgDLGEditorOptionsTitle
Dialog Editor Options
@@
@MsgDLGEditorOptions
List All Controls|Add New Control|Left Click Control|Right Click Control
@@
@MsgAdjustNewDLGControl
Choose control to click
@@
@MsgAddNewDLGControl1
Choose control type to add
@@
@MsgAddNewDLGControl2
Place Control At These Coordinates
@@
@MsgAddNewDLGControl3
Enter X then Y seperated by a comma
@@
@MsgCreatedNewControl
Added %1 at %2
@@

@MsgNewDLGPallett
RadioButton|CheckBox|Button|StaticText|EditableText|ListBox|ComboBox
@@
@MsgListNewControls
Controls In Dialog

%1
Press Escape to close this message
@@



;--- Help

@MsgSSHClientWindow
No scores are open.

To open a score press Control+O
To open a recently used file choose File > Open Recent File
To create a new score press Control+N

Press Escape to close this message.
@@

;Score window screen sensitive help
@MsgSSHScore
This is the score window.

Press Ctrl+Home to select the first item in the score.
Use the left and right arrow keys to move between notes and rests.
Hold down control and use the left and right arrows to move between bars.
Hold down the control and alt keys and then use the up and down arrows to move between staves.
F2 speaks the current staff.
F5 describes the currently selected item.
F6 speaks the rhythmic position of the selected item.
F7 speaks the position of the playback line.

To get help with Sibelius press JAWSKey + F1 twice.

Press Escape to close this message.
@@

@MsgSSHPickUpEdit
Type a number from 1 to 6 to enter a note.
6 = whole
5 = half
4 = quarter
3 = eighth
2 = sixteenth
1 = thirty-second

Once you enter a note, it will be represented by a letter.
W = whole
H = half
Q = quarter
E = eighth
X = sixteenth
Y = thirty-second

Use period to add a rhythm dot.

EG: to enter a dotted quarter type: 4 then period

Use plus to add two note lengths together.

EG: to create a pick up bar which is 5 eighths long, type 5 then + then 3

Press escape to close this message
@@
@MsgSSHNoteLengthEdit
Type a number from 1 to 6 to enter a note.
6 = whole
5 = half
4 = quarter
3 = eighth
2 = sixteenth
1 = thirty-second

Once you enter a note, it will be represented by a letter.
W = whole
H = half
Q = quarter
E = eighth
X = sixteenth
Y = thirty-second

Use period to add a rhythm dot.

EG: to enter a dotted quarter type: 4 then period

Press escape to close this message
@@


@MsgSymbolsGridTutorMsg
Use the arrow keys to move to a symbol and press space to select it.
@@
@MsgNoteValueEditTutorMsg
Enter note values with the numbers 1 through 6
@@


;key stroke help
;keystroke help messages
@MsgKeyStrokes
Keystrokes

Sibelius Access Options  %KeyFor(SibeliusAccessMenu)
Help with the current window or control  %KeyFor(ScreenSensitiveHelp)
Open Sibelius Access Guide  %KeyFor(ScreenSensitiveHelp) twice
Open score verbosity dialog %KeyFor(ScoreVerbosityDialog)

Information keystrokes
Describe the staff at the current position %KeyFor(SayStaffSummary)
Describe the instrument using the staff at the current position %KeyFor(SayInstrumentSummary)
Say system key, time signature and tempo at this position %KeyFor(SaySystemInfo)
Say system items close to the current position %KeyFor (SayNearBySystemItems)
Speak filtered text at this position %KeyFor(SayFilteredText)
Spell filtered text at this position %KeyFor(SayFilteredText) twice
Say filtered text ending at  this position %KeyFor(SayFilteredTextToItem)
Say filtered text starting at  this position %KeyFor(SayFilteredTextFromItem)
Say staff items close to this position %KeyFor(SayNearByStaffItems)
Describe current item or selection %KeyFor(SaySelection)
Say all concert pitches or text style %KeyFor(SayConcertPitches)
Say written pitch of selected note or text %KeyFor(SaySelectedNotesInChord)
Say concert pitch of selected note or text with formatting %KeyFor(SaySelectedNotesInChordConcert)
Say coordinates of selected item %KeyFor(SayItemCoordinates)
Say bar and rhythmic position of selected item %KeyFor(SayRhythmicInfo)
Say position of playback line %KeyFor(SayPlaybackPositionBarsAndBeats)
Say playback tempo  %KeyFor(SayPlaybackTempo)
Say current page number  %KeyFor(SayPageNumber)

Playback
Toggle metronome %KeyFor(ToggleMetronome)
Move playback line to selection  %KeyFor(PlaybackToSelection)
Select note close to playback line  %KeyFor(SelectionToPlayback)
Start and stop playback  SpaceBar
Play again  Control+SpaceBar
Next frame  Shift+]
Prior frame  Shift+[
Move playback to end  Control+]
Move playback to start  Control[
Increase playback speed  Alt+]
Decrease playback speed  Alt+[
Fastest playback speed  Control+Alt+]
Slowest playback speed  Control+Alt+[
Normal playback speed  Alt+Enter

Playback properties
Say live playback position %KeyFor(SayLivePlaybackPosition)
Say live playback duration %KeyFor(SayLivePlaybackDuration)
Say live playback velocity %KeyFor(SayLivePlaybackVelocity)
Move playback position left by 1 tick %KeyFor(MovePositionLeftSmall)
Move playback position left by 16 ticks %KeyFor(MovePositionLeftMedium)
Move playback position left by 64 ticks %KeyFor(MovePositionLeftLarge)
Move playback position right by 1 tick %KeyFor(MovePositionRightSmall)
Move playback position right by 16 ticks %KeyFor(MovePositionRightMedium)
Move playback position right by 64 ticks %KeyFor(MovePositionRightLarge)
Increase duration by 1 tick %KeyFor(IncreaseDurationSmall)
Increase duration by 8 ticks %KeyFor(IncreaseDurationMedium)
Increase duration by 32 ticks %KeyFor(IncreaseDurationLarge)
Decrease duration by 1 tick %KeyFor(DecreaseDurationSmall)
Decrease duration by 8 ticks %KeyFor(DecreaseDurationMedium)
Decrease duration by 32 ticks %KeyFor(DecreaseDurationLarge)
Increase velocity by 1 %KeyFor(IncreaseVelocitySmall)
Increase velocity by 8 %KeyFor(IncreaseVelocityMedium)
Increase velocity by 32 %KeyFor(IncreaseVelocityLarge)
Decrease velocity by 1 %KeyFor(DecreaseVelocitySmall)
Decrease velocity by 8 %KeyFor(DecreaseVelocityMedium)
Decrease velocity by 32 %KeyFor(DecreaseVelocityLarge)

Navigation
Clear selection (do this before playing MIDI keyboards)  Escape
Select the next score item  Tab
Select the previous score item  Shift+Tab
Select the next note or rest  RightArrow
Select the previous note or rest  LeftArrow
Select the first note or rest in the next bar  Control+RightArrow
Select the first note or rest in this bar or the previous bar  Control+LeftArrow
Select first staff item in score %KeyFor(TopOfFile)
Select last staff item in score %KeyFor(BottomOfFile)
Select the note above in the current chord %KeyFor(CloseListBox)
Select the note below in the current chord %KeyFor(OpenListBox)
Select the note or rest in the stave above  %KeyFor(UpCell)
Select the note or rest in the staff below  %KeyFor(DownCell)
Select the closest note or rest in the voice above  %KeyFor(MouseUp)
Select the closest note or rest in the voice below  %KeyFor(MouseDown)
Select next part of line %KeyFor(NextPartOfLine)
Select previous part of line %KeyFor(PriorPartOfLine)

Inputting
Start and stop note input %KeyFor(InputNotes)
Input zero on string %KeyFor(InputNotesOnString)
Start inputting appoggiaturas Period "%KeyFor(InputAppoggiaturas)"
Start inputting acciaccaturas Slash "%KeyFor(InputAcciaccaturas)"
Create slur above notes %KeyFor(AddSlurAbove)
Create slur below notes %KeyFor(AddSlurBelow)
Create hairpin crescendo %KeyFor(AddHairpinCrescendo)
Create hairpin decrescendo %KeyFor(AddHairpinDecrescendo)

BARS
Add single bar at end %KeyFor (AddBarAtEnd)
Add single bar after current bar %KeyFor(AddBarAtCurrent)

Extending Selections
Select entire score %KeyFor (SelectAll)
Select more  %KeyFor (SelectMore)
Select system  %KeyFor (SelectSystem)
Extend selection to next note, chord or rest Shift + RightArrow
Extend selection to previous note, chord or rest Shift + LeftArrow
Extend selection to end of current bar Control + Shift + RightArrow
Extend selection to start of current or previous bar Control + Shift + LeftArrow
Add stave below to selection  Shift + DownArrow
Add stave above to selection  Shift + UpArrow

Moving Objects
Use the arrow keys to move an item by one thirty-second of a space.
Use Control + Arrow keys to move an item by one line space.

Tool windows
Open or close keypad window  %KeyFor(OpenAndCloseKeypad)
Open or close playback window  %KeyFor(OpenAndClosePlayback)
Open or close mixer window  %KeyFor(OpenAndCloseMixer)
Open or close parts window %KeyFor(OpenAndClosePartsWindow)
Open or close video window  %KeyFor(OpenAndCloseVideo)
Open or close properties window  %KeyFor(OpenAndCloseProperties)
Open or close navigator window %KeyFor(OpenAndCloseNavigator)

Scores and parts
Switch to next open score  %KeyFor(NextDocumentWindow )
Switch to previous open score  %KeyFor(PreviousDocumentWindow )
Switch to next part %KeyFor(NextPart)
Switch to previous part %KeyFor(PriorPart)

Press Escape to close this message
@@

@MsgMixerKeystrokes
Keystrokes for Manipulating the Mixer

To switch between staff strips and group strips press CONTROL+TAB
To Move to the next strip press TAB
To move to the previous strip press SHIFT+TAB
To jump to the click strip press C
To jump to the master volume strip press A
To mute or unmute the current strip press M
To solo or unsolo the current strip press S
To speak the volume of the current strip press V
To set the volume to the default level press CONTROL+V
To increase the volume of the current strip press UP ARROW
To decrease the volume of the current strip press DOWN ARROW
To increase the volume of the current strip by a large amount press CONTROL+UP ARROW
To decrease the volume of the current strip by a large amount press CONTROL+DOWN ARROW
To play or stop the score press SPACE
To play again press CONTROL+SPACE
To rewind to the start of the score press CONTROL+[
To scroll the mixer down press PAGE DOWN
To scroll the mixer up press PAGE UP
To close the mixer and exit mode press ALT+CONTROL+M

Press ESCAPE to close this message.
@@

EndMessages